// Aufgabe3.cpp : Definiert den Einstiegspunkt fr die Konsolenanwendung.

#include "stdafx.h"
#include <iostream>
#include <fstream>
#include <iomanip>
#include <conio.h>
#include <string.h>

using namespace std;

//-------------------------------------------------------------------------
// konstante Faktoren und Namen
//-------------------------------------------------------------------------
#define ANZHOTEL  3
#define NAMELEN   30
#define NAMEDEC   NAMELEN+1
#define DOUBLELEN 20
const char Hoteldateiname [] = "U:\\Heiko Gorski\\Cplusplus\\Hotelliste.txt";

//-------------------------------------------------------------------------
// Strukturdeklarationen
//-------------------------------------------------------------------------
struct Hotel {char Name[NAMEDEC]; double Einnahmen;};

//-------------------------------------------------------------------------
// Eingaben und berechnete Werte
//-------------------------------------------------------------------------
double Eingabe;
double Minimum;
double Maximum;
double Summe;
double Durchschnitt;
Hotel  Hotelliste [ANZHOTEL];
char   buffer [10000];
int IndexDesMinimums;
int IndexDesMaximums;

//=========================================================================
// Hauptprogramm
//=========================================================================
int _tmain(int argc, _TCHAR* argv[])
{
	//---------------------------------------------------------------------
	// Daten zu den Hotels einlesen
	//---------------------------------------------------------------------
	for (int i=0; i<ANZHOTEL; i++)
	{
		cout << setw(2) << (i+1) << ". Hotelname.......: ";
		cin.getline (buffer, NAMELEN);
		strcpy (Hotelliste[i].Name, buffer);

		char *Errorptr = NULL;
		do
		{
			cout << setw(2) << (i+1) << ". Hoteleinnahme...: ";
			cin.getline (buffer, DOUBLELEN);
			Eingabe = strtod (buffer, &Errorptr);
			if (*Errorptr) cout << "keine gltige Zahl: " << buffer;
			Hotelliste[i].Einnahmen = Eingabe;
		}
		while (*Errorptr);
	}

	//---------------------------------------------------------------------
	// Daten zu den Hotels verarbeiten
	//---------------------------------------------------------------------
	for (int i=0; i<ANZHOTEL; i++)
	{
		Summe = Summe + Hotelliste[i].Einnahmen;

		if (0 == i)
		{
			Maximum = Hotelliste[i].Einnahmen;
			IndexDesMaximums = 0;
			Minimum = Hotelliste[i].Einnahmen;
			IndexDesMinimums = 0;
		}
		else
		{
			if (Maximum < Hotelliste[i].Einnahmen)
			{
				Maximum = Hotelliste[i].Einnahmen;
				IndexDesMaximums = i;
			}

			if (Minimum > Hotelliste[i].Einnahmen)
			{
				Minimum = Hotelliste[i].Einnahmen;
				IndexDesMinimums = i;
			}
		}
	}

	Durchschnitt = Summe / ANZHOTEL;

	//----------------------------------------------------------------------
	// Ausgabe 
	//----------------------------------------------------------------------
	cout << endl;

	//----------------------------------------------------------------------
	// ios_base::fmtflags oldflags = cout.flags(ios::fixed);
	// streamsize         oldprec  = cout.precision(2);
	//----------------------------------------------------------------------
    // ios::fixed    - Mit fester Anzahl von Nachkommastellen anzeigen 
    // ios::showpos  - Auch positive Zahlen mit Vorzeichen anzeigen 
	// ios::internal - Auffllen auf Ausgabebreite zwischen Vorzeichen & Zahl
	// Durch das Bit-Oder zeichen (| = AltGr auf <) 
	//----------------------------------------------------------------------
	int  oldflags = cout.flags(ios::fixed | ios::showpos | ios::internal);
	int  oldprec  = cout.precision(2);
	
	cout << "Bestes Ergebnis (HudeFaBiPB)...: " << setw(10) << Maximum      
		<< " (Hotel: " << Hotelliste[IndexDesMaximums].Name << ")" << endl;
	cout << "Schlechtestes Ergebnis (Lager).: " << setw(10) << Minimum
		<< " (Hotel: " << Hotelliste[IndexDesMinimums].Name << ")" << endl;
	cout << "Durchschnitt...................: " << setw(10) << Durchschnitt << endl;

	cout.precision (oldprec);
	cout.flags     (oldflags);

	//----------------------------------------------------------------------
	// Liste in eine Datei schreiben
	//----------------------------------------------------------------------
	ofstream Hoteldatei (Hoteldateiname);
	if (Hoteldatei.good())
	{
		Hoteldatei.precision(2);
		Hoteldatei.flags(ios::fixed | ios::showpos);
		for (int i=0; i<ANZHOTEL; i++)
		{
			Hoteldatei.fill ('.');
			Hoteldatei << left << setw(NAMELEN) << Hotelliste[i].Name << ": ";
			Hoteldatei.fill (' ');
			Hoteldatei << internal << setw(10)  << Hotelliste[i].Einnahmen << endl;
		}
		Hoteldatei << endl;
	    Hoteldatei << "Bestes Ergebnis (HudeFaBiPB)...: " << Hotelliste[IndexDesMaximums].Name << endl;
		Hoteldatei << "Schlechtestes Ergebnis (Lager).: " << Hotelliste[IndexDesMinimums].Name << endl;
	}
	else 
	{
		cout << "Fehler beim Schreiben der Datei: " << Hoteldatei.fail() << endl;
	}


	_getch(); // getch() ist deprecated
	return 0;
}


