// templates.cpp : Definiert den Einstiegspunkt fr die Konsolenanwendung.
//

#include "stdafx.h"
#include <iostream>
#include <conio.h>

using namespace std;

//--------------------------------------
// Absolutwert, ein Templateparameter
//--------------------------------------
template <class T> T Absolutwert (T x) 
{ 
	return (x < 0) ? -x : x; 
};

//--------------------------------------
// Quadrat, ein Templateparameter
//--------------------------------------
template <class T> T Quadrat (T x) 
{ 
	return x * x; 
};

//--------------------------------------
// Signum, ein Templateparameter
//--------------------------------------
template <class T> int Signum (T x) 
{ 
	return (x < 0) ? -1 : 1; 
};

//--------------------------------------
// Maximum, zwei Templateparameter, beide
// mssen vom gleichen Typ sein
//--------------------------------------
template <class T> T Maximum (T x, T y) 
{ 
	return (x > y) ? x : y; 
};

//--------------------------------------
// Minimum, zwei Templateparameter, beide
// mssen vom gleichen Typ sein
//--------------------------------------
template <class T> T Minimum (T x, T y) 
{ 
	return (x < y) ? x : y; 
};

//--------------------------------------
// Potenzfunktion mit einem Template-
// parameter, Potenz soll ganzzahlig
// positiv sein
//--------------------------------------
template <class T> T Potenz (T x, const unsigned int p) 
{ 
	if (p == 0) return 1;
	T ergebnis = 1;
	for (unsigned int i=0; i<p; i++)
	{
		ergebnis = ergebnis * x;
	}
	return ergebnis; 
};

//--------------------------------------
// Klassische Funktion, da Fakultt nur
// fr positive, ganze Zahlen definiert 
// ist
//--------------------------------------
long long Fakultaet (unsigned int x) 
{ 
	if (x < 2) return 1;
	long long ergebnis = 1;
	for (unsigned int i=x; i>1; i--)
	{
		ergebnis = ergebnis * i;
	}
	return ergebnis; 
}

//--------------------------------------
// Istkleinerals
//--------------------------------------
template <class T, class U> bool Istkleinerals (T x, U y) 
{ 
	return (x < y) ? true : false; 
};

int _tmain(int argc, _TCHAR* argv[])
{
	cout << "Fakultaet von   8       : " << Fakultaet   (8)      << endl;
	cout << "4. Potenz von   3       : " << Potenz      (3, 4)   << endl;
	cout << "4. Potenz von   3.3     : " << Potenz      (3.3, 4) << endl;
	cout << "Absolutwert zu  8       : " << Absolutwert (8)      << endl;
	cout << "Absolutwert zu -8       : " << Absolutwert (-8)     << endl;
	cout << "Absolutwert zu  1.8     : " << Absolutwert (1.8)    << endl;
	cout << "Absolutwert zu -1.8     : " << Absolutwert (-1.8)   << endl;
	cout << "Minimum von  8   und 0  : " << Minimum (8, 0)       << endl;
	cout << "Minimum von -8.1 und 0.7: " << Minimum (-8.1, 0.7)  << endl;
	cout << "Maximum von  8   und 0  : " << Maximum (8, 0)       << endl;
	cout << "Maximum von -8.1 und 0.7: " << Maximum (-8.1, 0.7)  << endl;
	cout << "Signum  von -8.1        : " << Signum  (-8.1)       << endl;
	cout << "Signum  von  8.1        : " << Signum  (8.1)        << endl;
	cout << "Signum  von -8          : " << Signum  (-8)         << endl;
	cout << "Signum  von  8          : " << Signum  (8)          << endl;
	//cout << "Minimum von -8.3 und 0  : " << Minimum (-8.3, 0)    << endl;
	
	while (!_kbhit());
	return 0;
}

